
void change_text(GtkWidget *widget, gpointer *data)
{
   GtkWidget *menu_separator;
   change_dialog_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_container_set_border_width(GTK_CONTAINER(change_dialog_window), 10);   

   main_dialog_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(change_dialog_window), main_dialog_box);
   gtk_widget_show(main_dialog_box);

   text_dialog_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(main_dialog_box), text_dialog_box, FALSE, FALSE, 5);
   gtk_widget_show(text_dialog_box);
   edited_text = gtk_text_new(0, 0);
   gtk_widget_set_usize(GTK_WIDGET(edited_text), 250, 250);
   gtk_box_pack_start(GTK_BOX(text_dialog_box), edited_text, FALSE, FALSE, 0);
   edited_scroller = gtk_vscrollbar_new(GTK_TEXT(edited_text)->vadj);
   gtk_box_pack_start(GTK_BOX(text_dialog_box), edited_scroller, FALSE, FALSE, 0);
   gtk_text_set_editable(GTK_TEXT(edited_text), TRUE);
   gtk_widget_show(edited_text);
   gtk_widget_show(edited_scroller);

   menu_separator = gtk_hseparator_new();
   gtk_box_pack_start (GTK_BOX(main_dialog_box), menu_separator, FALSE, FALSE, 10);
   gtk_widget_show (menu_separator);

   buttons_box = gtk_hbox_new(TRUE, 0);
   gtk_box_pack_end(GTK_BOX(main_dialog_box), buttons_box, FALSE, FALSE, 5);
   gtk_widget_show(buttons_box);

   ok_button = gtk_button_new_with_label(" OK ");
   gtk_box_pack_start(GTK_BOX(buttons_box), ok_button, FALSE, TRUE, 15);
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(save_text), GTK_OBJECT(edited_text));
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(change_dialog_window));
   gtk_widget_show(ok_button);

   cancel_button = gtk_button_new_with_label("Cancel");
   gtk_box_pack_start(GTK_BOX(buttons_box), cancel_button, FALSE, TRUE, 15);   
   gtk_signal_connect(GTK_OBJECT(cancel_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(change_dialog_window));
   gtk_widget_show(cancel_button);

   gchar *all_text = gtk_editable_get_chars(GTK_EDITABLE(cur_file->item_text), 0, -1);
   gtk_text_insert(GTK_TEXT(edited_text), 0, &black, 0, all_text, -1);
   gtk_widget_grab_focus(GTK_WIDGET(ok_button));
   gtk_widget_show(change_dialog_window);
}


void save_text(GtkWidget *widget, GtkWidget *text)
{
   gtk_editable_delete_text(GTK_EDITABLE(cur_file->item_text), 0, -1);
   gchar *all_text = gtk_editable_get_chars(GTK_EDITABLE(text), 0, -1);
   gtk_text_insert(GTK_TEXT(cur_file->item_text), 0, &black, 0, all_text, -1);

   char input[1024];
   char buffer[256] = "";
   GtkLabel *label;
   gchar *label_text;
   ifstream Input;
   ofstream Output;

   Input.open(cur_file->tempfile);
   Output.open(tempfile);

   label = GTK_LABEL(GTK_BIN(cur_file->cur_selected_item)->child);
   gtk_label_get(label, &label_text);
   strcat(buffer, "name=[");
   strcat(buffer, label_text);
   strcat(buffer, "]");
   
   while(Input.getline(input, 1024) != NULL)
   {
      if((strstr(input, buffer)) != NULL)
      {
         Output << input << endl;
         Output << all_text << endl;
         do
         {
            Input.getline(input, 1024);
         }
         while((strstr(input, "Tree")) == NULL);
      }
      Output << input << endl;
   }
   Input.close();
   Output.close();
   copy_file(tempfile, cur_file->tempfile);
   GtkWidget *temp = cur_file->cur_selected_item;
   gtk_tree_item_deselect(GTK_TREE_ITEM(cur_file->cur_selected_item));
   cur_file->saved = FALSE;
   gtk_tree_item_select(GTK_TREE_ITEM(temp));
}      

      
void change_image(GtkWidget *widget, gpointer *data)
{
   GtkWidget *menu_separator;
   change_dialog_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_container_set_border_width(GTK_CONTAINER(change_dialog_window), 10);   

   main_dialog_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(change_dialog_window), main_dialog_box);
   gtk_widget_show(main_dialog_box);

   pixmap_entry = gnome_pixmap_entry_new("n/a", "Change Image", 1);
   gtk_box_pack_start(GTK_BOX(main_dialog_box), pixmap_entry, FALSE, FALSE, 10);
   gnome_pixmap_entry_set_preview_size(GNOME_PIXMAP_ENTRY(pixmap_entry), 250, 250);
   gtk_widget_show(pixmap_entry);

   menu_separator = gtk_hseparator_new();
   gtk_box_pack_start (GTK_BOX(main_dialog_box), menu_separator, FALSE, FALSE, 10);
   gtk_widget_show (menu_separator);

   buttons_box = gtk_hbox_new(TRUE, 0);
   gtk_box_pack_end(GTK_BOX(main_dialog_box), buttons_box, FALSE, FALSE, 5);
   gtk_widget_show(buttons_box);

   ok_button = gtk_button_new_with_label(" OK ");
   gtk_box_pack_start(GTK_BOX(buttons_box), ok_button, FALSE, TRUE, 15);
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(save_image), 0);
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(change_dialog_window));
   gtk_widget_show(ok_button);

   cancel_button = gtk_button_new_with_label("Cancel");
   gtk_box_pack_start(GTK_BOX(buttons_box), cancel_button, FALSE, TRUE, 15);   
   gtk_signal_connect(GTK_OBJECT(cancel_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(change_dialog_window));
   gtk_widget_show(cancel_button);

   gtk_widget_grab_focus(GTK_WIDGET(ok_button));
   gtk_widget_show(change_dialog_window);
}


void save_image(GtkWidget *widget, gpointer *data)
{
   char input[1024];
   char buffer[256] = "";
   char *char_ptr;
   GtkLabel *label;
   gchar *label_text;
   ifstream Input;
   ofstream Output;

   Input.open(cur_file->tempfile);
   Output.open(tempfile);

   label = GTK_LABEL(GTK_BIN(cur_file->cur_selected_item)->child);
   gtk_label_get(label, &label_text);
   strcat(buffer, "name=[");
   strcat(buffer, label_text);
   strcat(buffer, "]");
   
   while(Input.getline(input, 1024) != NULL)
   {
      if((strstr(input, buffer)) != NULL)
      {
         if((char_ptr = strstr(input, "image=[")) != NULL)
	 {
	    char_ptr += 6;
            *char_ptr = '\0';
            char_ptr++;
	    while((*char_ptr != ']') && (*char_ptr != '\0'))
	       char_ptr++;
            Output << input << "[" << gnome_pixmap_entry_get_filename(GNOME_PIXMAP_ENTRY(pixmap_entry)) << char_ptr << endl;
            *input = '\0';
	 }
	 else
	 {
            if((char_ptr = strrchr(input, '>')) != NULL)
	    {
	       *char_ptr = '\0';
	       Output << input << " image=[" << gnome_pixmap_entry_get_filename(GNOME_PIXMAP_ENTRY(pixmap_entry)) << "]>" << endl;
               *input = '\0';
	    }
	 }
      }
      Output << input << endl;
   }
   Input.close();
   Output.close();
   copy_file(tempfile, cur_file->tempfile);
   GtkWidget *temp = cur_file->cur_selected_item;
   gtk_tree_item_deselect(GTK_TREE_ITEM(cur_file->cur_selected_item));
   cur_file->saved = FALSE;
   gtk_tree_item_select(GTK_TREE_ITEM(temp));
}      


void insert_new_cat(GtkWidget *widget, gpointer *data)
{
   change_dialog_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_window_set_title(GTK_WINDOW(change_dialog_window), "Insert new category");
   gtk_widget_set_usize(GTK_WIDGET(change_dialog_window), 350,135);
   gtk_container_set_border_width(GTK_CONTAINER(change_dialog_window), 10);   
   main_dialog_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(change_dialog_window), main_dialog_box);
   gtk_widget_show(main_dialog_box);

   entry_dialog_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(main_dialog_box), entry_dialog_box, FALSE, FALSE, 0);
   gtk_widget_show(entry_dialog_box);
   dialog_label = gtk_label_new("Category Name:");
   gtk_box_pack_start(GTK_BOX(entry_dialog_box), dialog_label, FALSE, FALSE, 0);
   gtk_widget_show(dialog_label);   
   dialog_entry = gtk_entry_new();
   gtk_box_pack_start(GTK_BOX(entry_dialog_box), dialog_entry, FALSE, FALSE, 0);
   gtk_widget_show(dialog_entry);   

   buttons_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_end(GTK_BOX(main_dialog_box), buttons_box, FALSE, FALSE, 5);
   gtk_widget_show(buttons_box);

   cancel_button = gtk_button_new_with_label("Cancel");
   gtk_box_pack_end(GTK_BOX(buttons_box), cancel_button, FALSE, FALSE, 5);   
   gtk_signal_connect(GTK_OBJECT(cancel_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(change_dialog_window));
   gtk_widget_show(cancel_button);

   ok_button = gtk_button_new_with_label(" OK ");
   gtk_box_pack_end(GTK_BOX(buttons_box), ok_button, FALSE, FALSE, 5);
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(insert_cat), GTK_OBJECT(dialog_entry));
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(change_dialog_window));
   gtk_widget_show(ok_button);
   gtk_widget_show(change_dialog_window);
}


void insert_cat(GtkWidget *widget, gpointer *data)
{
   GtkWidget *new_tree;
   GtkWidget *new_tree_item;
   gchar *cat_name;
   cat_name = gtk_entry_get_text(GTK_ENTRY(dialog_entry));
   new_tree_item = gtk_tree_item_new_with_label(cat_name);
   gtk_tree_append(GTK_TREE(cur_file->tree_widget), new_tree_item);
   new_tree = gtk_tree_new();
   gtk_tree_item_set_subtree(GTK_TREE_ITEM(new_tree_item), new_tree);
   gtk_signal_connect_object(GTK_OBJECT(new_tree_item), "select", GTK_SIGNAL_FUNC(show_selected_item), 0);
   gtk_signal_connect_object(GTK_OBJECT(new_tree_item), "deselect", GTK_SIGNAL_FUNC(unshow_selected_item), 0);
   gtk_widget_show(new_tree_item);
   
   char input[1024];
   char buffer[256] = "";
   ifstream Input;
   ofstream Output;

   Input.open(cur_file->tempfile);
   Output.open(tempfile);

   while(Input.getline(input, 1024) != NULL)
   {
      Output << input << endl;
   }
   Output << "<Tree name=[" << cat_name << "] image=[]>" << endl;
   Output << cat_name << " page." << endl;
   Output << "</Tree>" << endl;
   Output << input << endl;
   Input.close();
   Output.close();
   copy_file(tempfile, cur_file->tempfile);
   cur_file->saved = FALSE;
   adjust_sensitivity();
}


void insert_new_subcat(GtkWidget *widget, gpointer *data)
{
   change_dialog_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_window_set_title(GTK_WINDOW(change_dialog_window), "Insert new sub category");
   gtk_widget_set_usize(GTK_WIDGET(change_dialog_window), 350,135);
   gtk_container_set_border_width(GTK_CONTAINER(change_dialog_window), 10);   
   main_dialog_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(change_dialog_window), main_dialog_box);
   gtk_widget_show(main_dialog_box);

   entry_dialog_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(main_dialog_box), entry_dialog_box, FALSE, FALSE, 0);
   gtk_widget_show(entry_dialog_box);
   dialog_label = gtk_label_new("Category Name:");
   gtk_box_pack_start(GTK_BOX(entry_dialog_box), dialog_label, FALSE, FALSE, 0);
   gtk_widget_show(dialog_label);   
   dialog_entry = gtk_entry_new();
   gtk_box_pack_start(GTK_BOX(entry_dialog_box), dialog_entry, FALSE, FALSE, 0);
   gtk_widget_show(dialog_entry);   

   buttons_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_end(GTK_BOX(main_dialog_box), buttons_box, FALSE, FALSE, 5);
   gtk_widget_show(buttons_box);

   cancel_button = gtk_button_new_with_label("Cancel");
   gtk_box_pack_end(GTK_BOX(buttons_box), cancel_button, FALSE, FALSE, 5);   
   gtk_signal_connect(GTK_OBJECT(cancel_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(change_dialog_window));
   gtk_widget_show(cancel_button);

   ok_button = gtk_button_new_with_label(" OK ");
   gtk_box_pack_end(GTK_BOX(buttons_box), ok_button, FALSE, FALSE, 5);
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(insert_subcat), GTK_OBJECT(dialog_entry));
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(change_dialog_window));
   gtk_widget_show(ok_button);
   gtk_widget_show(change_dialog_window);
}


void insert_subcat(GtkWidget *widget, gpointer *data)
{
   GtkWidget *new_tree;
   GtkWidget *new_tree_item;
   gchar *cat_name;
   cat_name = gtk_entry_get_text(GTK_ENTRY(dialog_entry));
   new_tree_item = gtk_tree_item_new_with_label(cat_name);
   gtk_tree_append(GTK_TREE(GTK_TREE_ITEM(cur_file->cur_selected_item)->subtree), new_tree_item);
   new_tree = gtk_tree_new();
   gtk_tree_item_set_subtree(GTK_TREE_ITEM(new_tree_item), new_tree);
   gtk_signal_connect_object(GTK_OBJECT(new_tree_item), "select", GTK_SIGNAL_FUNC(show_selected_item), 0);
   gtk_signal_connect_object(GTK_OBJECT(new_tree_item), "deselect", GTK_SIGNAL_FUNC(unshow_selected_item), 0);
   gtk_widget_show(new_tree_item);
   
   char input[1024];
   char buffer[256] = "";

   ifstream Input;
   ofstream Output;
   Input.open(cur_file->tempfile);
   Output.open(tempfile);

   GtkLabel *label;
   gchar *tree_text;
   label = GTK_LABEL(GTK_BIN(cur_file->cur_selected_item)->child);
   gtk_label_get(label, &tree_text);
   strcat(buffer, "name=[");
   strcat(buffer, tree_text);
   strcat(buffer, "]");
   
   while(Input.getline(input, 1024) != NULL)
   {
      Output << input << endl;
      if((strstr(input, buffer)) != NULL)
      {
         while(Input.getline(input, 1024) != NULL)
         {
            if((strstr(input, "Tree")) == NULL)
            {
               Output << input << endl;
            }
            else
            {
               Output << "<Tree name=[" << cat_name << "] image=[]>" << endl;
               Output << cat_name << " page." << endl;
               Output << "</Tree>" << endl;
               Output << input << endl;
               break;
            }
         }
      }
   }
   Input.close();
   Output.close();
   copy_file(tempfile, cur_file->tempfile);   
   GtkWidget *temp = cur_file->cur_selected_item;
   gtk_tree_item_deselect(GTK_TREE_ITEM(cur_file->cur_selected_item));
   cur_file->saved = FALSE;
   gtk_tree_item_select(GTK_TREE_ITEM(temp));
}


void insert_new_item(GtkWidget *widget, gpointer *data)
{
   change_dialog_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_window_set_title(GTK_WINDOW(change_dialog_window), "Insert new category");
   gtk_widget_set_usize(GTK_WIDGET(change_dialog_window), 350,135);
   gtk_container_set_border_width(GTK_CONTAINER(change_dialog_window), 10);   
   main_dialog_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(change_dialog_window), main_dialog_box);
   gtk_widget_show(main_dialog_box);

   entry_dialog_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(main_dialog_box), entry_dialog_box, FALSE, FALSE, 0);
   gtk_widget_show(entry_dialog_box);
   dialog_label = gtk_label_new("Item Name:");
   gtk_box_pack_start(GTK_BOX(entry_dialog_box), dialog_label, FALSE, FALSE, 0);
   gtk_widget_show(dialog_label);
   dialog_entry = gtk_entry_new();
   gtk_box_pack_start(GTK_BOX(entry_dialog_box), dialog_entry, FALSE, FALSE, 0);
   gtk_widget_show(dialog_entry);   

   buttons_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_end(GTK_BOX(main_dialog_box), buttons_box, FALSE, FALSE, 5);
   gtk_widget_show(buttons_box);

   cancel_button = gtk_button_new_with_label("Cancel");
   gtk_box_pack_end(GTK_BOX(buttons_box), cancel_button, FALSE, FALSE, 5);   
   gtk_signal_connect(GTK_OBJECT(cancel_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(change_dialog_window));
   gtk_widget_show(cancel_button);

   ok_button = gtk_button_new_with_label(" OK ");
   gtk_box_pack_end(GTK_BOX(buttons_box), ok_button, FALSE, FALSE, 5);
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(insert_item), GTK_OBJECT(dialog_entry));
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(change_dialog_window));
   gtk_widget_show(ok_button);
   gtk_widget_show(change_dialog_window);
}


void insert_item(GtkWidget *widget, gpointer *data)
{
   GtkWidget *new_tree_item;
   gchar *item_name;
   item_name = gtk_entry_get_text(GTK_ENTRY(dialog_entry));
   new_tree_item = gtk_tree_item_new_with_label(item_name);
   gtk_tree_append(GTK_TREE(GTK_TREE_ITEM(cur_file->cur_selected_item)->subtree), new_tree_item);
   gtk_signal_connect_object(GTK_OBJECT(new_tree_item), "select", GTK_SIGNAL_FUNC(show_selected_item), 0);
   gtk_signal_connect_object(GTK_OBJECT(new_tree_item), "deselect", GTK_SIGNAL_FUNC(unshow_selected_item), 0);
   gtk_widget_show(new_tree_item);

   char input[1024];
   char buffer[256] = "";

   ifstream Input;
   ofstream Output;
   Input.open(cur_file->tempfile);
   Output.open(tempfile);

   GtkLabel *label;
   gchar *tree_text;
   label = GTK_LABEL(GTK_BIN(cur_file->cur_selected_item)->child);
   gtk_label_get(label, &tree_text);
   strcat(buffer, "name=[");
   strcat(buffer, tree_text);
   strcat(buffer, "]");

   while(Input.getline(input, 1024) != NULL)
   {
      Output << input << endl;
      if((strstr(input, buffer)) != NULL)
      {
         while(Input.getline(input, 1024) != NULL)
         {
            if((strstr(input, "Tree")) == NULL)
            {
               Output << input << endl;
            }
            else
            {
               Output << "<TreeItem name=[" << item_name << "] image=[]>" << endl;
               Output << item_name << " page." << endl;
               Output << "</TreeItem>" << endl;
               Output << input << endl;
               break;
            }
         }
      }
   }
   Input.close();
   Output.close();
   copy_file(tempfile, cur_file->tempfile);
   GtkWidget *temp = cur_file->cur_selected_item;
   gtk_tree_item_deselect(GTK_TREE_ITEM(cur_file->cur_selected_item));
   cur_file->saved = FALSE;
   gtk_tree_item_select(GTK_TREE_ITEM(temp));
}


void item_to_category(GtkWidget *widget, gpointer *data)
{
   GtkWidget *new_tree;
   new_tree = gtk_tree_new();
   gtk_widget_hide(cur_file->cur_selected_item);   
   gtk_tree_item_set_subtree(GTK_TREE_ITEM(cur_file->cur_selected_item), new_tree);   

   char input[1024];
   char buffer[256] = "";
   char *char_ptr;
   
   ifstream Input;
   ofstream Output;
   Input.open(cur_file->tempfile);
   Output.open(tempfile);

   GtkLabel *label;
   gchar *tree_text;
   label = GTK_LABEL(GTK_BIN(cur_file->cur_selected_item)->child);
   gtk_label_get(label, &tree_text);
   strcat(buffer, "name=[");
   strcat(buffer, tree_text);
   strcat(buffer, "]");

   while(Input.getline(input, 1024) != NULL)
   {
      if((strstr(input, buffer)) != NULL)
      {
         char_ptr = strchr(input, ' ');
	 char_ptr ++;
         Output << "<Tree "<< char_ptr << endl;
         while(Input.getline(input, 1024) != NULL)
         {
            if((strstr(input, "Tree")) != NULL)
            {
               Input.getline(input, 1024);
               break;
            }
            Output << input << endl;
         }
         Output << "</Tree>" << endl;
      }
      Output << input << endl;
   }
   Input.close();
   Output.close();
   copy_file(tempfile, cur_file->tempfile);
   gtk_widget_show(cur_file->cur_selected_item);   
   gtk_tree_item_select(GTK_TREE_ITEM(cur_file->cur_selected_item));
   cur_file->cur_selected_tree = GTK_TREE_ITEM(cur_file->cur_selected_item)->subtree;
   cur_file->saved = FALSE;
   adjust_sensitivity();
}


void category_to_item(GtkWidget *widget, gpointer *data)
{
   gtk_widget_hide(cur_file->cur_selected_item);
   gtk_tree_item_remove_subtree(GTK_TREE_ITEM(cur_file->cur_selected_item));   
   
   char input[1024];
   char buffer[256] = "";
   char *char_ptr;
   ifstream Input;
   ofstream Output;
   Input.open(cur_file->tempfile);
   Output.open(tempfile);

   GtkLabel *label;
   gchar *tree_text;
   label = GTK_LABEL(GTK_BIN(cur_file->cur_selected_item)->child);
   gtk_label_get(label, &tree_text);
   strcat(buffer, "name=[");
   strcat(buffer, tree_text);
   strcat(buffer, "]");

   while(Input.getline(input, 1024) != NULL)
   {
      if((strstr(input, buffer)) != NULL)
      {
         char_ptr = strchr(input, ' ');
	 char_ptr ++;
         Output << "<TreeItem " << char_ptr << endl;
         while(Input.getline(input, 1024) != NULL)
         {
            if((strstr(input, "Tree")) != NULL)
            {
               Input.getline(input, 1024);
               break;
            }
            Output << input << endl;
         }
         Output << "</TreeItem>" << endl;
      }
      Output << input << endl;
   }
   Input.close();
   Output.close();
   copy_file(tempfile, cur_file->tempfile);
   gtk_widget_show(cur_file->cur_selected_item);
   cur_file->saved = FALSE;
   cur_file->cur_selected_tree = NULL;
   adjust_sensitivity();
}


void delete_item(GtkWidget *widget, gpointer *data)
{
   char input[1024];
   char buffer[256] = "";

   ifstream Input;
   ofstream Output;
   Input.open(cur_file->tempfile);
   Output.open(tempfile);

   GtkLabel *label;
   gchar *tree_text;
   label = GTK_LABEL(GTK_BIN(cur_file->cur_selected_item)->child);
   gtk_label_get(label, &tree_text);
   strcat(buffer, "name=[");
   strcat(buffer, tree_text);
   strcat(buffer, "]");
   while(Input.getline(input, 1024) != NULL)
   {
      if((strstr(input, buffer)) != NULL)
      {
         while(Input.getline(input, 1024) != NULL)
         {
            if((strstr(input, "</TreeItem")) != NULL)
            {
               Input.getline(input, 1024);
               break;
            }
         }
      }
      Output << input << endl;
   }
   Input.close();
   Output.close();
   copy_file(tempfile, cur_file->tempfile);
   gtk_editable_delete_text(GTK_EDITABLE(cur_file->item_text), 0, -1);
   gtk_widget_destroy(cur_file->cur_selected_item);
   cur_file->cur_selected_item = NULL;
   cur_file->cur_selected_tree = NULL;
   cur_file->saved = FALSE;
   adjust_sensitivity();
   cur_file->image_str[0] = '\0';
   display_image(cur_file->image_str);
}
