
void make_tree(GtkWidget *tree, const char *filename)
{
   GtkWidget *sub_tree[15];
   GtkWidget *main_item;
   GtkWidget *sub_item;
   char buffer[257];
   char *char_ptr;
   char *str_ptr;
   int tree_counter = 0;
   ifstream Input;
   Input.open(filename);
   
   if(!Input)
   {
      cout << "There was a problem finding the file " << filename << endl;
      return;
   }
   
   sub_tree[0] = tree;   // point this to the root tree.
   
   while(Input.getline(buffer, 256) != NULL)
   {

      if(((strstr(buffer, "<Tree ")) != NULL) && ((char_ptr = strstr(buffer, "name=[")) != NULL))
      {
         char_ptr += 6;
         str_ptr = char_ptr;
	 while((*char_ptr != ']') && (*char_ptr != '\0'))
	    char_ptr++;
         *char_ptr = '\0';
         main_item = gtk_tree_item_new_with_label(str_ptr);
         gtk_tree_append(GTK_TREE(sub_tree[tree_counter]), main_item);
         tree_counter++;
         sub_tree[tree_counter] = gtk_tree_new();
         gtk_tree_item_set_subtree(GTK_TREE_ITEM(main_item), sub_tree[tree_counter]);
         gtk_signal_connect_object(GTK_OBJECT(main_item), "select", GTK_SIGNAL_FUNC(show_selected_item), 0);
         gtk_signal_connect_object(GTK_OBJECT(main_item), "deselect", GTK_SIGNAL_FUNC(unshow_selected_item), 0);
         gtk_widget_show(sub_tree[tree_counter]);
         gtk_widget_show(main_item);
         continue;
      }

      if(((strstr(buffer, "<TreeItem ")) != NULL) && ((char_ptr = strstr(buffer, "name=[")) != NULL))
      {
         char_ptr += 6;
         str_ptr = char_ptr;
	 while((*char_ptr != ']') && (*char_ptr != '\0'))
	    char_ptr++;
         *char_ptr = '\0';
         sub_item = gtk_tree_item_new_with_label(str_ptr);
         gtk_tree_append(GTK_TREE(sub_tree[tree_counter]), sub_item);
         gtk_signal_connect_object(GTK_OBJECT(sub_item), "select", GTK_SIGNAL_FUNC(show_selected_item), 0);
         gtk_signal_connect_object(GTK_OBJECT(sub_item), "deselect", GTK_SIGNAL_FUNC(unshow_selected_item), 0);
         gtk_widget_show(sub_item);         
         continue;
      }
      
      if((strstr(buffer, "</Tree>")) != NULL)
      {
         tree_counter--;         
         continue;
      }

      if((strstr(buffer, "</TreeItem>")) != NULL)
      {
         continue;
      }

   }
   Input.close();
}
         
         
